(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/router'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('kst-gridstack', ['exports', '@angular/core', '@angular/router', '@angular/common'], factory) :
    (global = global || self, factory(global['kst-gridstack'] = {}, global.ng.core, global.ng.router, global.ng.common));
}(this, function (exports, core, router, common) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var GridStackDirective = /** @class */ (function () {
        function GridStackDirective(el, renderer) {
            this.el = el;
            this.renderer = renderer;
            this.options = {
                cellHeight: 80,
                verticalMargin: 10
            };
            this.gridInited = new core.EventEmitter();
            renderer.setAttribute(el.nativeElement, 'class', 'grid-stack');
        }
        /**
         * @return {?}
         */
        GridStackDirective.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var self = this;
            /** @type {?} */
            var renderer = this.renderer;
            /** @type {?} */
            var nativeElement = this.el.nativeElement;
            /** @type {?} */
            var animate = this.animate ? 'yes' : 'no';
            renderer.setAttribute(nativeElement, 'data-gs-width', String(this.w));
            if (animate === 'yes') {
                renderer.setAttribute(nativeElement, 'data-gs-animate', animate);
            }
            // tslint:disable-next-line: variable-name
            /** @type {?} */
            var _default = {
                cellHeight: 80,
                verticalMargin: 10
            };
            /** @type {?} */
            var opt = Object.assign(_default, this.options);
            // TODO: listen to an event here instead of just waiting for the time to expire 
            setTimeout((/**
             * @return {?}
             */
            function () {
                /** @type {?} */
                var $grid = $('.grid-stack').gridstack(opt);
                self.gridInited.emit($grid);
            }), 10);
        };
        GridStackDirective.decorators = [
            { type: core.Directive, args: [{
                        // tslint:disable-next-line:directive-selector
                        selector: '[gridStack]'
                    },] }
        ];
        /** @nocollapse */
        GridStackDirective.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: core.Renderer2 }
        ]; };
        GridStackDirective.propDecorators = {
            w: [{ type: core.Input }],
            animate: [{ type: core.Input }],
            options: [{ type: core.Input }],
            gridInited: [{ type: core.Output }]
        };
        return GridStackDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var UUID = /** @class */ (function () {
        function UUID() {
        }
        /**
         * @param {?} len
         * @param {?=} radix
         * @return {?}
         */
        UUID.uuid = /**
         * @param {?} len
         * @param {?=} radix
         * @return {?}
         */
        function (len, radix) {
            /** @type {?} */
            var chars = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz'.split('');
            /** @type {?} */
            var uuid = [];
            /** @type {?} */
            var i;
            radix = radix !== undefined ? radix : chars.length;
            if (len) {
                // Compact form
                // tslint:disable-next-line: no-bitwise  
                for (i = 0; i < len; i++)
                    uuid[i] = chars[0 | Math.random() * radix];
            }
            else {
                // rfc4122, version 4 form
                /** @type {?} */
                var r = void 0;
                // rfc4122 requires these characters
                uuid[8] = uuid[13] = uuid[18] = uuid[23] = '-';
                uuid[14] = '4';
                // Fill in random data.  At i==19 set the high bits of clock sequence as
                // per rfc4122, sec. 4.1.5
                for (i = 0; i < 36; i++) {
                    if (!uuid[i]) {
                        // tslint:disable-next-line: no-bitwise
                        r = 0 | Math.random() * 16;
                        // tslint:disable-next-line: no-bitwise
                        uuid[i] = chars[(i === 19) ? (r & 0x3) | 0x8 : r];
                    }
                }
            }
            return uuid.join('');
        };
        return UUID;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var GridStackItemDirective = /** @class */ (function () {
        function GridStackItemDirective(el, renderer) {
            this.el = el;
            this.renderer = renderer;
            renderer.setElementAttribute(el.nativeElement, 'class', 'grid-stack-item');
            this.id = UUID.uuid(10);
        }
        // tslint:disable-next-line:use-life-cycle-interface
        // tslint:disable-next-line:use-life-cycle-interface
        /**
         * @return {?}
         */
        GridStackItemDirective.prototype.ngOnInit = 
        // tslint:disable-next-line:use-life-cycle-interface
        /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var renderer = this.renderer;
            /** @type {?} */
            var nativeElement = this.el.nativeElement;
            /** @type {?} */
            var cannotResize = this.canResize ? 'yes' : 'no';
            renderer.setElementAttribute(nativeElement, 'data-gs-x', String(this.x));
            renderer.setElementAttribute(nativeElement, 'data-gs-y', String(this.y));
            renderer.setElementAttribute(nativeElement, 'data-gs-width', String(this.w));
            renderer.setElementAttribute(nativeElement, 'data-gs-height', String(this.h));
            renderer.setElementAttribute(nativeElement, 'data-gs-id', String(this.id));
            renderer.setElementAttribute(nativeElement, 'id', String(this.id));
            if (this.minWidth) {
                renderer.setElementAttribute(nativeElement, 'data-gs-min-width', String(this.minWidth));
            }
            if (cannotResize === 'yes') {
                renderer.setElementAttribute(nativeElement, 'data-gs-no-resize', cannotResize);
            }
        };
        GridStackItemDirective.decorators = [
            { type: core.Directive, args: [{
                        // tslint:disable-next-line:directive-selector
                        selector: '[gridStackItem]'
                    },] }
        ];
        /** @nocollapse */
        GridStackItemDirective.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: core.Renderer }
        ]; };
        GridStackItemDirective.propDecorators = {
            x: [{ type: core.Input }],
            y: [{ type: core.Input }],
            w: [{ type: core.Input }],
            h: [{ type: core.Input }],
            minWidth: [{ type: core.Input }],
            canResize: [{ type: core.Input }],
            id: [{ type: core.Input }]
        };
        return GridStackItemDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DraggableDirective = /** @class */ (function () {
        function DraggableDirective(el, renderer2) {
            this.el = el;
            this.renderer2 = renderer2;
            this.stackSelector = '.k-draggable';
            this.appendTo = 'body';
            this.helper = 'clone';
        }
        /**
         * @return {?}
         */
        DraggableDirective.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var self = this;
            self.renderer2.addClass(this.el.nativeElement, 'k-draggable');
            $(this.el.nativeElement).draggable({
                helper: this.helper,
                revert: "invalid",
                stack: this.stackSelector,
                appendTo: this.appendTo,
                drag: (/**
                 * @param {?} event
                 * @param {?} ui
                 * @return {?}
                 */
                function (event, ui) {
                    if (self.drag) {
                        self.drag(event, ui);
                    }
                }),
                start: (/**
                 * @param {?} event
                 * @param {?} ui
                 * @return {?}
                 */
                function (event, ui) {
                    if (self.start) {
                        self.start(event, ui);
                    }
                }),
                stop: (/**
                 * @param {?} event
                 * @param {?} ui
                 * @return {?}
                 */
                function (event, ui) {
                    if (self.stop) {
                        self.stop(event, ui);
                    }
                }),
            });
        };
        DraggableDirective.decorators = [
            { type: core.Directive, args: [{
                        // tslint:disable-next-line:directive-selector
                        selector: '[draggable]'
                    },] }
        ];
        /** @nocollapse */
        DraggableDirective.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: core.Renderer2 }
        ]; };
        DraggableDirective.propDecorators = {
            stop: [{ type: core.Input, args: ['stop',] }],
            start: [{ type: core.Input, args: ['start',] }],
            drag: [{ type: core.Input, args: ['drag',] }],
            stackSelector: [{ type: core.Input, args: ['stack',] }],
            appendTo: [{ type: core.Input, args: ['appendTo',] }],
            helper: [{ type: core.Input }]
        };
        return DraggableDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DroppableDirective = /** @class */ (function () {
        function DroppableDirective(el) {
            this.el = el;
            this.accept = '.accepted';
        }
        /**
         * @return {?}
         */
        DroppableDirective.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var self = this;
            $(this.el.nativeElement).droppable({
                accept: this.accept,
                drop: (/**
                 * @param {?} event
                 * @param {?} ui
                 * @return {?}
                 */
                function (event, ui) {
                    if (self.drop) {
                        self.drop(event, ui);
                    }
                }),
                over: (/**
                 * @param {?} event
                 * @param {?} ui
                 * @return {?}
                 */
                function (event, ui) {
                    if (self.over) {
                        self.over(event, ui);
                    }
                }),
                out: (/**
                 * @param {?} event
                 * @param {?} ui
                 * @return {?}
                 */
                function (event, ui) {
                    if (self.out) {
                        self.out(event, ui);
                    }
                })
            });
        };
        DroppableDirective.decorators = [
            { type: core.Directive, args: [{
                        // tslint:disable-next-line:directive-selector
                        selector: '[droppable]'
                    },] }
        ];
        /** @nocollapse */
        DroppableDirective.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        DroppableDirective.propDecorators = {
            drop: [{ type: core.Input, args: ['drop',] }],
            over: [{ type: core.Input, args: ['over',] }],
            out: [{ type: core.Input, args: ['out',] }],
            accept: [{ type: core.Input }]
        };
        return DroppableDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var GridStackModule = /** @class */ (function () {
        function GridStackModule() {
        }
        GridStackModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [
                            GridStackDirective,
                            GridStackItemDirective,
                            DraggableDirective,
                            DroppableDirective
                        ],
                        exports: [
                            GridStackDirective,
                            GridStackItemDirective,
                            DraggableDirective,
                            DroppableDirective
                        ],
                        imports: [
                            common.CommonModule,
                            router.RouterModule
                        ],
                        providers: []
                    },] }
        ];
        /** @nocollapse */
        GridStackModule.ctorParameters = function () { return []; };
        return GridStackModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Layout = /** @class */ (function () {
        function Layout(id, name, items) {
            this.name = '';
            this.items = [];
            this.name = name;
            this.items = items;
            this.id = id;
        }
        return Layout;
    }());
    var LayoutItem = /** @class */ (function () {
        function LayoutItem(js) {
            this.height = 4; // 比列 *cellheight
            // 比列 *cellheight
            this.width = 4; // 比列 *width
            if (js !== undefined) {
                this.height = js['height'];
                this.width = js['width'];
                this.minHeight = js['minHeight'];
                this.minWidth = js['minWidth'];
                this.maxHeight = js['maxHeight'];
                this.maxWidth = js['maxWidth'];
                this.x = js['x'];
                this.y = js['y'];
                this.componentName = js['componentName'];
                if (js['id'] !== undefined)
                    this._id = js['id'];
                else {
                    this._id = UUID.uuid(10);
                }
                this.dataOptins = js['dataOptins'];
            }
        }
        Object.defineProperty(LayoutItem.prototype, "id", {
            get: /**
             * @return {?}
             */
            function () {
                return this._id;
            },
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this._id = val;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} js
         * @return {?}
         */
        LayoutItem.fromJS = /**
         * @param {?} js
         * @return {?}
         */
        function (js) {
            return new LayoutItem(js);
        };
        return LayoutItem;
    }());
    var CreateLayoutEntity = /** @class */ (function () {
        function CreateLayoutEntity() {
        }
        return CreateLayoutEntity;
    }());
    var DeleteLayoutEntity = /** @class */ (function () {
        function DeleteLayoutEntity() {
        }
        return DeleteLayoutEntity;
    }());

    exports.CreateLayoutEntity = CreateLayoutEntity;
    exports.DeleteLayoutEntity = DeleteLayoutEntity;
    exports.DraggableDirective = DraggableDirective;
    exports.DroppableDirective = DroppableDirective;
    exports.GridStackDirective = GridStackDirective;
    exports.GridStackItemDirective = GridStackItemDirective;
    exports.GridStackModule = GridStackModule;
    exports.Layout = Layout;
    exports.LayoutItem = LayoutItem;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=kst-gridstack.umd.js.map
